/* debug.h - super simple debugging */
/* Sun 17 May 2020 02:22:00 PM EDT */
/* $Id: debug.h,v 1.24 2024/03/27 18:11:32 malakai Exp $ */

#ifndef LO_DEBUG_H
#define LO_DEBUG_H

#define DEBUG_INPUT 		(1<<0)
#define DEBUG_MOBACT		(1<<1)
#define DEBUG_SKILL_USE		(1<<2)
#define DEBUG_SKILL_FAIL	(1<<3)
#define DEBUG_FIGHT			(1<<4)
#define DEBUG_MOBFLAGS		(1<<5)
#define DEBUG_TMAP			(1<<6)
#define DEBUG_DB			(1<<7)
#define DEBUG_BREAK			(1<<8)
#define DEBUG_TESTING			(1<<9)
#define DEBUG_PATHER			(1<<10)
#define DEBUG_EXPLORATION		(1<<11)
#define DEBUG_TELNET		(1<<12)
#define DEBUG_KNOWLEDGE			(1<<13)
#define DEBUG_WATER			(1<<14)
#define DEBUG_JOURNAL			(1<<15)
#define DEBUG_CRAFTING			(1<<16)
#define DEBUG_ITEMDAM			(1<<17)
#define DEBUG_MAGIC			(1<<18)
#define DEBUG_PULSE			(1<<19)
#define DEBUG_EVENT			(1<<20)
#define DEBUG_GMCP			(1<<21)
#define DEBUG_MAX			(22)

#define lo_debug(facility, args...) if(global_debug_facility & facility) { lo_Debug( facility, __func__, args); }

/* exported global variable. */
extern unsigned int global_debug_facility;

/* exported function definitions */
void lo_debug_init(void);
void lo_Debug(int facility, const char *caller, char *str, ...);
void do_debug(struct char_data *ch, char *argument, int cmd);
int lo_breakpoint(int code);
void lo_perror(const char *s);

#endif
